/*

CELLULAR AUTOMATA GENERATOR
a tool for generating images and videos
based on Cellular Automata concept.
change rules and colour palettes on the go,
add your images, use brushes and share
the results with other sketches or applications
via Syphon. sync to music for live performances!

Ksawery Kirklewski
www.ksawerykomputery.pl/tools/ca-generator
5-01-2020

*/

// Syphon
import codeanticode.syphon.*;
SyphonServer server;

// Sets
int WindowW, WindowH;
String modeSet;
int scale = 0;
int maxZoom = 64;

boolean sendSyphon = true;
boolean automator = true;

void setup() {
  size(1920, 700, P3D);
  noSmooth();
  frameRate(30);

  hint(DISABLE_TEXTURE_MIPMAPS);
  ((PGraphicsOpenGL)g).textureSampling(2);
  
  WindowW = 512;
  WindowH = 512;
  
  modeSet = "RULES";
  
  /* default */
  ruleSet = "Bob";
  brushSet = "Rect";  
  initScreen(scale);
  loadPaletteThumbs();  
  setPalette("Greyscale");
  loadImages();
  loadBrushes();
  initConsole();
  if(sendSyphon) server = new SyphonServer(this, "CA");
  initScreen(2);  
  if(automator) initAutomator();
}

void draw() {
  background(bgColor);
  CA();
  drawing();
  updateConsole();
  rec();
  if(sendSyphon) server.sendImage(screen);
}
