PGraphics screenshot;

void keyPressed() {
  
  automatorListen();
  
  if( key != '\\' && key != '[' && key != ']' ) { screenSave(outputTemp); }
  
  switch(key) {
    
    case '1': modeSet = "RULES"; break;
    case '2': modeSet = "PALETTES"; break;
    case '3': modeSet = "IMAGES"; break;
    case '4': modeSet = "BRUSHES"; break;
    case '5': modeSet = "GLITCHES"; break;
    
    case '7': automatorOn(); break;
    case '8': clearAutomator(); break;
    case '9': eraserAutomator(); break;
    
    case '0': recOn(); break;
    case '.': loadPerlinMap(); break;
    case ' ': pauseScreen(); break;
    
    case '-': initScreen(0.5); break;
    case '=': initScreen(2); break;
    
    case '[': screenSave(outputClipboard); break;
    case ']': screenPaste(outputClipboard); break;
    case '\\': screenPaste(outputTemp); break;
    
    case BACKSPACE: clearScreen(); break;
    case ENTER: screenSaveToFile(); break;

  }
  
  
  switch(modeSet) {
    
    case "RULES":
      for(int i=0; i<RULES.length; i++) {
        if(key==RULES[i].shortcut) { setRule(RULES[i].name); break; }
      }
      break;
  
    case "PALETTES":
      for(int i=0; i<PALETTES.length; i++) {
        if(key==PALETTES[i].shortcut) { setPalette(PALETTES[i].name); PALETTES[i].createThumb(); break; }
      }
      break;
    
    case "BRUSHES":
      for(int i=0; i<BRUSHES.length; i++) {
        if(key==BRUSHES[i].shortcut) { setBrush(BRUSHES[i].name); break; }
      }
      break;
    
    case "IMAGES":
      for(int i=0; i<IMAGES.length; i++) {
        if(key==IMAGES[i].shortcut) { addImage(IMAGES[i].image); break; }
      }
      break;
    
    case "GENERATE":
      for(int i=0; i<GENERATE.length; i++) {
        if(key==GENERATE[i].shortcut) { addElement(GENERATE[i].name); break; }
      }
      break;
      
  }
}


void mousePressed() {
  screenSave(outputTemp);
  automatorListen();
}
