PImage screen;
PGraphics output;

PGraphics outputTemp;
PGraphics outputClipboard;

int[][] buffer;
int W, H;
int margin;

void initScreen(float newscale) {
    
  if(scale==0) {
    
    scale = 1;
    W = WindowW;
    H = WindowH;
    
    output = createGraphics(W, H);
    output.beginDraw();
    output.imageMode(CENTER);
    output.background(0);
    output.endDraw();

  } else if( scale * newscale>=1 && scale * newscale <= maxZoom ) {
    
    scale*=newscale;
    W = WindowW / scale;
    H = WindowH / scale;
    
    outputTemp = output;
    output = createGraphics(W, H);
    
    output.beginDraw();
    output.imageMode(CENTER);
    output.image(outputTemp, W/2, H/2, W, H);
    output.endDraw();
    
  }
  
  outputClipboard = createGraphics(W, H); 
  outputTemp = createGraphics(W, H); 
  
  buffer = new int[W][H];
  screen = createImage(W, H, RGB);
    
  margin = (height-WindowH)/2;
  
  loadPerlinMap();
  
}

void screenSave(PGraphics temp) {
  temp.beginDraw();
  temp.imageMode(CENTER);
  temp.image(output, W/2, H/2, W, H);
  temp.endDraw();
  //println("Screen copied.");
}

void screenPaste(PGraphics temp) {
  output.beginDraw();
  output.imageMode(CENTER);
  output.image(temp, W/2, H/2, W, H);
  output.endDraw();
  //println("Screen pasted.");
}

void clearScreen() {
  output.beginDraw();
  output.background(0);
  output.endDraw();
}

String tempSet;
void pauseScreen() {
  if(ruleSet == "(none)") { ruleSet = tempSet; } else { tempSet = ruleSet; ruleSet = "(none)"; }
}

void screenSaveToFile() {
  screen.save("screenshots/ca-screenshot-"+year()+"-"+month()+"-"+day()+"-"+hour()+"-"+minute()+"-"+second()+".tif");
  println("Screen saved!");
}
