boolean isHovered, isClicked;
int mouseHoldTime;

color bgColor = 235;
color textColor = 100;
color linkColor = 0;
color activeColor = color(0,0,255);
color hoverColor = color(208,225,255);
color pressColor = color(170,205,255);

void initConsole() {
  textFont(createFont("Courier",12));
  textSize(12);
  textLeading(12);
}

void updateConsole() {
  
  isHovered = false;
  
  int padding = 80;
  
  
  textAlign(RIGHT,BOTTOM); 
  fill(textColor);
  text("FPS: " + round(frameRate), width-20, height-20);
  
  
  textAlign(LEFT,TOP); 
  translate(WindowW+margin+padding, margin);
  
  float titleBarHeight = 50;
  float optionHeight = 25;
  
  pushMatrix();
    fill( modeSet == "RULES" ? activeColor : linkColor);
    text("1  RULES",0,0);
    translate(0, titleBarHeight);
    for(int i=0; i<RULES.length; i++) {
      createHover(-10,-7,150,optionHeight);
      if(isClicked) setRule(RULES[i].name);
      fill( ruleSet == RULES[i].name ? activeColor : linkColor);
      text(RULES[i].shortcut + "  " + RULES[i].name,0,0);
      translate(0,optionHeight);
    }
  popMatrix();
  
  
  translate(90+padding,0);
    
  pushMatrix();
    fill( modeSet == "PALETTES" ? activeColor : linkColor);
    text("2  PALETTES",0,0);
    translate(0, titleBarHeight);
    int palettesCols = 2;
    for(int i=0; i<PALETTES.length; i++) {
      int ix = i % palettesCols * 170;
      int iy = i / palettesCols * 60;
      createHover(ix-10,iy-10,170,60);
      if(isClicked) { setPalette(PALETTES[i].name); PALETTES[i].createThumb(); }
      fill( paletteSet == PALETTES[i].name ? activeColor : linkColor);
      image(PALETTES[i].thumb,ix,iy);
      text(PALETTES[i].name + "\n" + PALETTES[i].shortcut,ix+50,iy+7);
    }
  popMatrix();
  
  
  translate(300+padding,0);
  
  pushMatrix();
    fill( modeSet == "IMAGES" ? activeColor : linkColor);
    text("3  IMAGES",0,0);
    translate(0, titleBarHeight);
    int imagesCols = 4;
    for(int i=0; i<IMAGES.length; i++) {
      int ix = i % imagesCols * 55;
      int iy = i / imagesCols * 68;
      createHover(ix-8,iy-8,55,68);
      if(isClicked) addImage(IMAGES[i].image);
      fill(linkColor);
      image(IMAGES[i].thumb,ix,iy);
      text(IMAGES[i].shortcut,ix,iy+45);
    }
  popMatrix();
  
  
  translate(190+padding,0);
  
  pushMatrix();
    fill( modeSet == "BRUSHES" ? activeColor : linkColor);
    text("4  BRUSHES",0,0);
    translate(0, titleBarHeight);
    for(int i=0; i<BRUSHES.length; i++) {
      createHover(-10,-7,120,optionHeight);
      if(isClicked) setBrush(BRUSHES[i].name);
      fill( brushSet == BRUSHES[i].name ? activeColor : linkColor);
      text(BRUSHES[i].shortcut + "  " + BRUSHES[i].name,0,0);
      translate(0,optionHeight);
    }
    
    translate(0,50);
    fill( modeSet == "GENERATE" ? activeColor : linkColor);
    text("5  GENERATE",0,0);
    translate(0, titleBarHeight);
    for(int i=0; i<GENERATE.length; i++) {
      createHover(-10,-7,120,optionHeight);
      if(isClicked) addElement(GENERATE[i].name);
      fill(linkColor);
      text(GENERATE[i].shortcut + "  " + GENERATE[i].name,0,0);
      translate(0,optionHeight);
    }
  popMatrix();
  
  
  translate(70+padding,0);
  
  
  pushMatrix();
    text("SETTINGS",0,0);
    translate(0, titleBarHeight);
    
    fill(linkColor);
    text("SIZE: " + WindowW/scale+"x"+WindowH/scale, 0, 0);
    translate(0, optionHeight);
    
    for(int i=0; i<7; i++) {
      createHover(30*i-4, -4, 30, 20);
      if(isClicked) { scale = int(pow(2,i)); initScreen(1); }
      fill( scale == int(pow(2,i)) ? activeColor : linkColor);
      text(int(pow(2,9-i)), 30*i, 0);
    }
      
    translate(0, 2*optionHeight);
    
    
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { pauseScreen(); }
    fill(linkColor);
    if(ruleSet == "(none)") {
      text("_ START", 0, 0);
    } else {
      text("_ PAUSE", 0, 0);
    }
      
    translate(0, optionHeight);
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { clearScreen(); }
    fill(linkColor);
    text("⌫ CLEAR SCREEN", 0, 0);
    
    translate(0, optionHeight);
    
    
    if(automator) {
    
      if(automatorOn) {
        fill(0,255,0);
        text("7 AUTOMATOR ON", 0, 0);
      } else {
        fill(textColor);
        text("7 AUTOMATOR OFF", 0, 0);
      }
    
      fill(textColor);
      translate(0, optionHeight);
      text("8 AUTOMATOR CLEAR", 0, 0);
      translate(0, optionHeight);
      text("9 AUTOMATOR ERASE ", 0, 0);
      
      translate(0, optionHeight);
      
    }
    
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { recOn(); }
    if(isRecording) {
      fill(255,0,0);
      text("0 RECORDED: "+framesRecorded, 0, 0);
    } else {
      fill(linkColor);
      text("0 RECORD", 0, 0);
    }
    
    translate(0, optionHeight);
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { screenSaveToFile(); }
    fill(linkColor);
    text("⏎ SAVE TO FILE", 0, 0); 
    
    translate(0, optionHeight);
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { screenSave(outputClipboard); }
    fill(linkColor);
    text("[ CLIPBOARD COPY", 0, 0); 
    
    translate(0, optionHeight);
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { screenPaste(outputClipboard); }
    fill(linkColor);
    text("] CLIPBOARD PASTE", 0, 0); 
    
    translate(0, optionHeight);
    
    createHover(-10,-7,150,optionHeight);
    if(isClicked) { loadPerlinMap(); }
    fill(linkColor);
    text(". RELOARD PERLIN", 0, 0);
    
  popMatrix();
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  if(mousePressed) {
    mouseHoldTime++;
  } else {
    mouseHoldTime=0;
  }
  
  
  cursor( isHovered ? HAND : ARROW );
  
}


void createHover(float x, float y, float w, float h) {
  
  boolean hovered = false;
  
  if( mouseX > modelX(0,0,0)+x && mouseX < modelX(0,0,0)+w+x && mouseY > modelY(0,0,0)+y && mouseY < modelY(0,0,0)+h+y ) {
    isHovered = true;
    hovered = true;
  }
  
  isClicked = hovered && ( mouseHoldTime == 1 || mouseHoldTime > 10);
  
  noStroke();
  if(hovered) { fill(hoverColor); }
  if(isClicked) { fill(pressColor); }
  if(hovered) rect(x,y,w,h);
  
}
