import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress LOC;

boolean automatorOn = false;

String excludeChars = "7890-="; 

void initAutomator() {
  oscP5 = new OscP5(this,11000);
  LOC = new NetAddress("127.0.0.1",12000);
  clearAutomator();
}

void automatorOn() {
  automatorOn = !automatorOn;
}

void automatorListen() {
  if( automator && automatorOn ) {
    if( keyPressed && excludeChars.indexOf(key)<0 ) {
      OscMessage MSG = new OscMessage("K");
      MSG.add(key);
      oscP5.send(MSG, LOC);
    } else if(mousePressed) {
      OscMessage MSG = new OscMessage("M");
      MSG.add(mouseX);
      MSG.add(mouseY);
      oscP5.send(MSG, LOC);
    }
  }
}

void clearAutomator() {
  OscMessage MSG = new OscMessage("C");
  oscP5.send(MSG, LOC);
}

void eraserAutomator() {
  OscMessage MSG = new OscMessage("E");
  oscP5.send(MSG, LOC);
}

void oscEvent(OscMessage theOscMessage) {
  char type = theOscMessage.addrPattern().charAt(0);
  if(type=='k') {
    char keyT = theOscMessage.get(0).charValue();
    key = keyT;
    keyPressed();
  }
  if(type=='m') {
    int mouseXT = theOscMessage.get(0).intValue();
    int mouseYT = theOscMessage.get(1).intValue();
    mouseX = mouseXT;
    mouseY = mouseYT;
    mouseHoldTime = 1;
  }
}
