Brush[] BRUSHES = {
  new Brush("Rect", 'q'),
  new Brush("Line", 'w'),
  new Brush("Smooth", 'e'),
  new Brush("Spray", 'r')
};

float rect = 80;


/* ----- */


class Brush {
  String name;
  char shortcut;
  Brush(String iname, char ishortcut) {
    name = iname;
    shortcut = ishortcut;
  }
}


/* ----- */


String brushSet;
PImage smoothBrush;
PImage sprayBrush;
int px, py;

void loadBrushes() {
  smoothBrush = loadImage("brushes/smooth.png");
  sprayBrush = loadImage("brushes/spray.png");
}

void setBrush(String name) {
  brushSet = name;  
}

void drawing() {
  
  int x = (mouseX-margin)/scale;
  int y = (mouseY-margin)/scale;
    
  if( (mousePressed||mouseHoldTime>0) && mouseX > margin && mouseX < margin+W*scale && mouseY > margin && mouseY < margin+H*scale) {
  
    
    int c = 255;
    if (mouseButton == RIGHT) { c = 10; }
    output.fill(c);
    
    output.noStroke();
   
    output.beginDraw();
    if(brushSet == "Rect") { output.rect(x-rect*0.375/scale,y-rect/2/scale,rect*0.75/scale,rect/scale); }
    if(brushSet == "Line") { output.stroke(c); output.strokeWeight(5/scale); output.line(px,py,x,y); }
    if(brushSet == "Smooth") { output.image(smoothBrush, x, y, 50/scale, 50/scale); }
    if(brushSet == "Spray") { output.image(sprayBrush, x, y, 50/scale, 50/scale); }
    output.endDraw(); 
    
  }
  
   px=x; py=y;
   
}
